3 # Copyright (c) 2005, 2006 Junio C Hamano
8 git am [options] [(<mbox>|<Maildir>)...]
9 git am [options] (--resolved | --skip | --abort)
11 i,interactive run interactively
12 b,binary* (historical option -- no-op)
13 3,3way allow fall back on 3way merging if needed
15 s,signoff add a Signed-off-by line to the commit message
16 u,utf8 recode into utf8 (default)
17 k,keep pass -k flag to git-mailinfo
18 keep-non-patch pass -b flag to git-mailinfo
19 keep-cr pass --keep-cr flag to git-mailsplit for mbox format
20 no-keep-cr do not pass --keep-cr flag to git-mailsplit independent of am.keepcr
21 c,scissors strip everything before a scissors line
22 whitespace= pass it through git-apply
23 ignore-space-change pass it through git-apply
24 ignore-whitespace pass it through git-apply
25 directory= pass it through git-apply
26 exclude= pass it through git-apply
27 include= pass it through git-apply
28 C= pass it through git-apply
29 p= pass it through git-apply
30 patch-format= format the patch(es) are in
31 reject pass it through git-apply
32 resolvemsg= override error message when patch failure occurs
33 continue continue applying patches after resolving a conflict
34 r,resolved synonyms for --continue
35 skip skip the current patch
36 abort restore the original branch and abort the patching operation.
37 committer-date-is-author-date lie about committer date
38 ignore-date use current timestamp for author date
39 rerere-autoupdate update the index with reused conflict resolution if possible
40 rebasing* (internal use for git-rebase)"
44 prefix=$(git rev-parse --show-prefix)
49 git var GIT_COMMITTER_IDENT >/dev/null ||
50 die "$(gettext "You need to set your committer info first")"
52 if git rev-parse --verify -q HEAD >/dev/null
60 if test '' != "$interactive"
64 if test '' != "$threeway"
70 git rev-parse --sq-quote "$@"
74 echo "$1" >"$dotest/next"
75 git rev-parse --verify -q HEAD >"$dotest/abort-safety"
80 if test -f "$dotest/dirtyindex"
85 if ! test -s "$dotest/abort-safety"
90 abort_safety=$(cat "$dotest/abort-safety")
91 if test "z$(git rev-parse --verify -q HEAD)" = "z$abort_safety"
95 gettextln "You seem to have moved HEAD since the last 'am' failure.
96 Not rewinding to ORIG_HEAD" >&2
100 stop_here_user_resolve () {
101 if [ -n "$resolvemsg" ]; then
102 printf '%s\n' "$resolvemsg"
105 eval_gettextln "When you have resolved this problem run \"\$cmdline --resolved\".
106 If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
107 To restore the original branch and stop patching run \"\$cmdline --abort\"."
113 rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
114 "$dotest/patch" "$dotest/info"
115 echo "$next" >"$dotest/next"
121 gettextln "Cannot fall back to three-way merge."
126 O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
128 rm -fr "$dotest"/patch-merge-*
129 mkdir "$dotest/patch-merge-tmp-dir"
131 # First see if the patch records the index info that we can use.
132 cmd="git apply $git_apply_opt --build-fake-ancestor" &&
133 cmd="$cmd "'"$dotest/patch-merge-tmp-index" "$dotest/patch"' &&
135 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
136 git write-tree >"$dotest/patch-merge-base+" ||
137 cannot_fallback "$(gettext "Repository lacks necessary blobs to fall back on 3-way merge.")"
139 say Using index info to reconstruct a base tree...
141 cmd='GIT_INDEX_FILE="$dotest/patch-merge-tmp-index"'
143 if test -z "$GIT_QUIET"
145 eval "$cmd git diff-index --cached --diff-filter=AM --name-status HEAD"
148 cmd="$cmd git apply --cached $git_apply_opt"' <"$dotest/patch"'
151 mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
152 mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
154 cannot_fallback "$(gettext "Did you hand edit your patch?
155 It does not apply to blobs recorded in its index.")"
158 test -f "$dotest/patch-merge-index" &&
159 his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
160 orig_tree=$(cat "$dotest/patch-merge-base") &&
161 rm -fr "$dotest"/patch-merge-* || exit 1
163 say "$(gettext "Falling back to patching base and 3-way merge...")"
165 # This is not so wrong. Depending on which base we picked,
166 # orig_tree may be wildly different from ours, but his_tree
167 # has the same set of wildly different changes in parts the
168 # patch did not touch, so recursive ends up canceling them,
169 # saying that we reverted all those changes.
171 eval GITHEAD_$his_tree='"$FIRSTLINE"'
172 export GITHEAD_$his_tree
173 if test -n "$GIT_QUIET"
175 GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
177 git-merge-recursive $orig_tree -- HEAD $his_tree || {
178 git rerere $allow_rerere_autoupdate
179 echo Failed to merge in the changes.
182 unset GITHEAD_$his_tree
186 test $# = 0 || echo >&2 "$@"
193 check_patch_format () {
194 # early return if patch_format was set from the command line
195 if test -n "$patch_format"
200 # we default to mbox format if input is from stdin and for
202 if test $# = 0 || test "x$1" = "x-" || test -d "$1"
208 # otherwise, check the first few non-blank lines of the first
209 # patch to try to detect its format
211 # Start from first line containing non-whitespace
220 "From "* | "From: "*)
223 '# This series applies on GIT commit'*)
224 patch_format=stgit-series
226 "# HG changeset patch")
230 # if the second line is empty and the third is
231 # a From, Author or Date entry, this is very
232 # likely an StGIT patch
234 ,"From: "* | ,"Author: "* | ,"Date: "*)
242 if test -z "$patch_format" &&
247 # This begins with three non-empty lines. Is this a
248 # piece of e-mail a-la RFC2822? Grab all the headers,
249 # discarding the indented remainder of folded lines,
250 # and see if it looks like that they all begin with the
251 # header field names...
253 sed -n -e '/^$/q' -e '/^[ ]/d' -e p |
254 sane_egrep -v '^[!-9;-~]+:' >/dev/null ||
257 } < "$1" || clean_abort
261 case "$patch_format" in
263 if test -n "$rebasing" || test t = "$keepcr"
269 git mailsplit -d"$prec" -o"$dotest" -b $keep_cr -- "$@" > "$dotest/last" ||
275 clean_abort "$(gettext "Only one StGIT patch series can be applied at once")"
277 series_dir=`dirname "$1"`
284 set "$@" "$series_dir/$filename"
286 # remove the safety x
288 # remove the arg coming from the first-line comment
290 } < "$series_file" || clean_abort
291 # set the patch format appropriately
293 # now handle the actual StGIT patches
300 this=`expr "$this" + 1`
301 msgnum=`printf "%0${prec}d" $this`
302 # Perl version of StGIT parse_patch. The first nonemptyline
303 # not starting with Author, From or Date is the
304 # subject, and the body starts with the next nonempty
305 # line not starting with Author, From or Date
306 perl -ne 'BEGIN { $subject = 0 }
307 if ($subject > 1) { print ; }
308 elsif (/^\s+$/) { next ; }
309 elsif (/^Author:/) { s/Author/From/ ; print ;}
310 elsif (/^(From|Date)/) { print ; }
316 print "Subject: ", $_ ;
319 ' < "$stgit" > "$dotest/$msgnum" || clean_abort
321 echo "$this" > "$dotest/last"
329 this=$(( $this + 1 ))
330 msgnum=$(printf "%0${prec}d" $this)
331 # hg stores changeset metadata in #-commented lines preceding
332 # the commit message and diff(s). The only metadata we care about
333 # are the User and Date (Node ID and Parent are hashes which are
334 # only relevant to the hg repository and thus not useful to us)
335 # Since we cannot guarantee that the commit message is in
336 # git-friendly format, we put no Subject: line and just consume
337 # all of the message as the body
338 perl -M'POSIX qw(strftime)' -ne 'BEGIN { $subject = 0 }
339 if ($subject) { print ; }
340 elsif (/^\# User /) { s/\# User/From:/ ; print ; }
341 elsif (/^\# Date /) {
342 my ($hashsign, $str, $time, $tz) = split ;
343 $tz = sprintf "%+05d", (0-$tz)/36;
345 strftime("%a, %d %b %Y %H:%M:%S ",
348 } elsif (/^\# /) { next ; }
353 ' <"$hg" >"$dotest/$msgnum" || clean_abort
355 echo "$this" >"$dotest/last"
360 if test -n "$patch_format"
362 clean_abort "$(eval_gettext "Patch format \$patch_format is not supported.")"
364 clean_abort "$(gettext "Patch format detection failed.")"
371 dotest="$GIT_DIR/rebase-apply"
372 sign= utf8=t keep= keepcr= skip= interactive= resolved= rebasing= abort=
373 resolvemsg= resume= scissors= no_inbody_headers=
375 committer_date_is_author_date=
377 allow_rerere_autoupdate=
379 if test "$(git config --bool --get am.keepcr)" = true
390 echo >&2 "The $1 option has been a no-op for long time, and"
391 echo >&2 "it will be removed. Please do not use it anymore."
398 utf8=t ;; # this is now default
409 -r|--resolved|--continue)
416 rebasing=t threeway=t keep=t scissors=f no_inbody_headers=t ;;
418 die "$(gettext "-d option is no longer supported. Do not use.")"
421 shift; resolvemsg=$1 ;;
422 --whitespace|--directory|--exclude|--include)
423 git_apply_opt="$git_apply_opt $(sq "$1=$2")"; shift ;;
425 git_apply_opt="$git_apply_opt $(sq "$1$2")"; shift ;;
427 shift ; patch_format="$1" ;;
428 --reject|--ignore-whitespace|--ignore-space-change)
429 git_apply_opt="$git_apply_opt $1" ;;
430 --committer-date-is-author-date)
431 committer_date_is_author_date=t ;;
434 --rerere-autoupdate|--no-rerere-autoupdate)
435 allow_rerere_autoupdate="$1" ;;
450 # If the dotest directory exists, but we have finished applying all the
451 # patches in them, clear it out.
452 if test -d "$dotest" &&
453 last=$(cat "$dotest/last") &&
454 next=$(cat "$dotest/next") &&
456 test "$next" -gt "$last"
463 case "$#,$skip$resolved$abort" in
465 # Explicit resume command and we do not have file, so
469 # No file input but without resume parameters; catch
470 # user error to feed us a patch from standard input
471 # when there is already $dotest. This is somewhat
472 # unreliable -- stdin could be /dev/null for example
473 # and the caller did not intend to feed us a patch but
474 # wanted to continue unattended.
481 die "$(eval_gettext "previous rebase directory \$dotest still exists but mbox given.")"
484 case "$skip,$abort" in
486 die "$(gettext "Please make up your mind. --skip or --abort?")"
490 git read-tree --reset -u HEAD HEAD
491 orig_head=$(cat "$GIT_DIR/ORIG_HEAD")
493 git update-ref ORIG_HEAD $orig_head
496 if test -f "$dotest/rebasing"
498 exec git rebase --abort
503 git read-tree --reset -u HEAD ORIG_HEAD
509 rm -f "$dotest/dirtyindex"
511 # Make sure we are not given --skip, --resolved, nor --abort
512 test "$skip$resolved$abort" = "" ||
513 die "$(gettext "Resolve operation not in progress, we are not resuming.")"
516 mkdir -p "$dotest" || exit
518 if test -n "$prefix" && test $# != 0
523 test -n "$first" && {
527 if is_absolute_path "$arg"
531 set "$@" "$prefix$arg"
537 check_patch_format "$@"
541 # -i can and must be given when resuming; everything
543 echo " $git_apply_opt" >"$dotest/apply-opt"
544 echo "$threeway" >"$dotest/threeway"
545 echo "$sign" >"$dotest/sign"
546 echo "$utf8" >"$dotest/utf8"
547 echo "$keep" >"$dotest/keep"
548 echo "$scissors" >"$dotest/scissors"
549 echo "$no_inbody_headers" >"$dotest/no_inbody_headers"
550 echo "$GIT_QUIET" >"$dotest/quiet"
551 echo 1 >"$dotest/next"
552 if test -n "$rebasing"
554 : >"$dotest/rebasing"
556 : >"$dotest/applying"
557 if test -n "$HAS_HEAD"
559 git update-ref ORIG_HEAD HEAD
561 git update-ref -d ORIG_HEAD >/dev/null 2>&1
566 git update-index -q --refresh
572 files=$(git ls-files) ;;
574 files=$(git diff-index --cached --name-only HEAD --) ;;
578 test -n "$HAS_HEAD" && : >"$dotest/dirtyindex"
579 die "$(eval_gettext "Dirty index: cannot apply patches (dirty: \$files)")"
583 # Now, decide what command line options we will give to the git
584 # commands we invoke, based on the result of parsing command line
585 # options and previous invocation state stored in $dotest/ files.
587 if test "$(cat "$dotest/utf8")" = t
593 keep=$(cat "$dotest/keep")
602 case "$(cat "$dotest/scissors")" in
604 scissors=--scissors ;;
606 scissors=--no-scissors ;;
608 if test "$(cat "$dotest/no_inbody_headers")" = t
610 no_inbody_headers=--no-inbody-headers
614 if test "$(cat "$dotest/quiet")" = t
618 if test "$(cat "$dotest/threeway")" = t
622 git_apply_opt=$(cat "$dotest/apply-opt")
623 if test "$(cat "$dotest/sign")" = t
625 SIGNOFF=`git var GIT_COMMITTER_IDENT | sed -e '
627 s/^/Signed-off-by: /'
633 last=`cat "$dotest/last"`
634 this=`cat "$dotest/next"`
637 this=`expr "$this" + 1`
641 while test "$this" -le "$last"
643 msgnum=`printf "%0${prec}d" $this`
644 next=`expr "$this" + 1`
645 test -f "$dotest/$msgnum" || {
651 # If we are not resuming, parse and extract the patch information
652 # into separate files:
653 # - info records the authorship and title
654 # - msg is the rest of commit log message
655 # - patch is the patch body.
657 # When we are resuming, these files are either already prepared
658 # by the user, or the user can tell us to do so by --resolved flag.
661 git mailinfo $keep $no_inbody_headers $scissors $utf8 "$dotest/msg" "$dotest/patch" \
662 <"$dotest/$msgnum" >"$dotest/info" ||
665 # skip pine's internal folder data
666 sane_grep '^Author: Mail System Internal Data$' \
667 <"$dotest"/info >/dev/null &&
670 test -s "$dotest/patch" || {
671 eval_gettextln "Patch is empty. Was it split wrong?
672 If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
673 To restore the original branch and stop patching run \"\$cmdline --abort\"."
676 rm -f "$dotest/original-commit" "$dotest/author-script"
677 if test -f "$dotest/rebasing" &&
678 commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
679 -e q "$dotest/$msgnum") &&
680 test "$(git cat-file -t "$commit")" = commit
682 git cat-file commit "$commit" |
683 sed -e '1,/^$/d' >"$dotest/msg-clean"
684 echo "$commit" > "$dotest/original-commit"
685 get_author_ident_from_commit "$commit" > "$dotest/author-script"
688 sed -n '/^Subject/ s/Subject: //p' "$dotest/info"
692 git stripspace > "$dotest/msg-clean"
697 if test -f "$dotest/author-script"
699 eval $(cat "$dotest/author-script")
701 GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
702 GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
703 GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
706 if test -z "$GIT_AUTHOR_EMAIL"
708 gettextln "Patch does not have a valid e-mail address."
712 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
716 if test '' != "$SIGNOFF"
719 sed -ne '/^Signed-off-by: /p' \
720 "$dotest/msg-clean" |
724 test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
725 test '' = "$LAST_SIGNED_OFF_BY" && echo
732 if test -s "$dotest/msg-clean"
734 cat "$dotest/msg-clean"
736 if test '' != "$ADD_SIGNOFF"
740 } >"$dotest/final-commit"
743 case "$resolved$interactive" in
745 # This is used only for interactive view option.
746 git diff-index -p --cached HEAD -- >"$dotest/patch"
752 if test "$interactive" = t
755 die "$(gettext "cannot be interactive without stdin connected to a terminal.")"
757 while test "$action" = again
759 gettextln "Commit Body is:"
760 echo "--------------------------"
761 cat "$dotest/final-commit"
762 echo "--------------------------"
763 # TRANSLATORS: Make sure to include [y], [n], [e], [v] and [a]
764 # in your translation. The program will only accept English
765 # input at this point.
766 gettext "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
770 [aA]*) action=yes interactive= ;;
771 [nN]*) action=skip ;;
772 [eE]*) git_editor "$dotest/final-commit"
775 git_pager "$dotest/patch" ;;
783 if test -f "$dotest/final-commit"
785 FIRSTLINE=$(sed 1q "$dotest/final-commit")
790 if test $action = skip
796 if test -x "$GIT_DIR"/hooks/applypatch-msg
798 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
802 say "$(eval_gettext "Applying: \$FIRSTLINE")"
806 # When we are allowed to fall back to 3-way later, don't give
807 # false errors during the initial attempt.
809 if test "$threeway" = t
811 squelch='>/dev/null 2>&1 '
813 eval "git apply $squelch$git_apply_opt"' --index "$dotest/patch"'
817 # Resolved means the user did all the hard work, and
818 # we do not have to do any patch application. Just
819 # trust what the user has in the index file and the
822 git diff-index --quiet --cached HEAD -- && {
823 gettextln "No changes - did you forget to use 'git add'?
824 If there is nothing left to stage, chances are that something else
825 already introduced the same changes; you might want to skip this patch."
826 stop_here_user_resolve $this
828 unmerged=$(git ls-files -u)
829 if test -n "$unmerged"
831 gettextln "You still have unmerged paths in your index
832 did you forget to use 'git add'?"
833 stop_here_user_resolve $this
840 if test $apply_status != 0 && test "$threeway" = t
844 # Applying the patch to an earlier tree and merging the
845 # result may have produced the same tree as ours.
846 git diff-index --quiet --cached HEAD -- && {
847 say "$(gettext "No changes -- Patch already applied.")"
851 # clear apply_status -- we have successfully merged.
855 if test $apply_status != 0
857 eval_gettextln 'Patch failed at $msgnum $FIRSTLINE'
858 if test "$(git config --bool advice.amworkdir)" != false
860 eval_gettextln "The copy of the patch that failed is found in:
863 stop_here_user_resolve $this
866 if test -x "$GIT_DIR"/hooks/pre-applypatch
868 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
871 tree=$(git write-tree) &&
873 if test -n "$ignore_date"
877 parent=$(git rev-parse --verify -q HEAD) ||
878 say >&2 "$(gettext "applying to an empty history")"
880 if test -n "$committer_date_is_author_date"
882 GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
883 export GIT_COMMITTER_DATE
885 git commit-tree $tree ${parent:+-p} $parent <"$dotest/final-commit"
887 git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
890 if test -f "$dotest/original-commit"; then
891 echo "$(cat "$dotest/original-commit") $commit" >> "$dotest/rewritten"
894 if test -x "$GIT_DIR"/hooks/post-applypatch
896 "$GIT_DIR"/hooks/post-applypatch
902 if test -s "$dotest"/rewritten; then
903 git notes copy --for-rewrite=rebase < "$dotest"/rewritten
904 if test -x "$GIT_DIR"/hooks/post-rewrite; then
905 "$GIT_DIR"/hooks/post-rewrite rebase < "$dotest"/rewritten